// worker function declaration


extern long runningThreads;
extern HANDLE hiocp;
extern HANDLE suicideEvent;
extern int concurrency;


unsigned int __stdcall Worker( void *arg );


// OVERLAPPED wrapper to use as connection context


// I don't use completion keys; instead, I use the
// OVERLAPPED pointer to get at my OV struct below.
// this frees up the completion key, which I use to
// tell my workers to commit suicide.

#define COMPKEY_DIEDIEDIE ((DWORD) -1L)

enum State { stClosed, stAccepting, stReading, stWriting, stSendingFile };

// inheriting from OVERLAPPED limits us to
// one outstanding I/O per connection. Ask
// me if I care ...

// a note on initialReceiveSize: If the client starts sending
// ass soon as it has a connection, you can leave this value
// != 0. If, however, the client expects the server to offer
// a banner first, you *must* set initialReceiveSize to ZERO.
// If you don't, AcceptEx() will wait for the client to speak
// up, while the client waits for the server to say something!

struct OV: public OVERLAPPED
{
	static const int addrlen;
	static const int initialReceiveSize;
	const enum { bs = 4096 };

	DWORD tag; int ix; // makes debugging easier

	State state; // what the connection is doing
	SOCKET s; // the connection's socket handle
	DWORD n; // number of bytes received or sent
	char *end; // points to first free byte in buf
	bool ignore; // == true to ignore rest of currently received line
	string reply; // the reply will be built in this buffer
	sockaddr_in local, peer; // addresses

	// the following stuff keeps temporary state for transmitting a file
	bool sendFile; // true if we have a file to send
	HANDLE hf; // file handle
	string tfHead, tfTail; // header and trailer for the file
	TRANSMIT_FILE_BUFFERS tfb; // to pass the head/tail to TF()

	char buf[bs]; // receive buffer

	OV(): tag( '@@@@' ), state( stClosed ), end( buf ), ignore( false ), sendFile( false )
		{ Internal = InternalHigh = Offset = OffsetHigh = 0; hEvent = 0; }
};
